/*
╔══════════════════════════════════════════════════════════════════════════════╗
║                       SIMPLY POWERFUL TOOLKIT (SPTK)                         ║
║                       UDPSocket.cpp - description                            ║
╟──────────────────────────────────────────────────────────────────────────────╢
║  begin                Thursday May 25 2000                                   ║
║  copyright            (C) 1999-2018 by Alexey Parshin. All rights reserved.  ║
║  email                alexeyp@gmail.com                                      ║
╚══════════════════════════════════════════════════════════════════════════════╝
┌──────────────────────────────────────────────────────────────────────────────┐
│   This library is free software; you can redistribute it and/or modify it    │
│   under the terms of the GNU Library General Public License as published by  │
│   the Free Software Foundation; either version 2 of the License, or (at your │
│   option) any later version.                                                 │
│                                                                              │
│   This library is distributed in the hope that it will be useful, but        │
│   WITHOUT ANY WARRANTY; without even the implied warranty of                 │
│   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library   │
│   General Public License for more details.                                   │
│                                                                              │
│   You should have received a copy of the GNU Library General Public License  │
│   along with this library; if not, write to the Free Software Foundation,    │
│   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.               │
│                                                                              │
│   Please report all bugs and problems to alexeyp@gmail.com.                  │
└──────────────────────────────────────────────────────────────────────────────┘
*/

#include <sptk5/net/UDPSocket.h>

using namespace std;
using namespace sptk;

UDPSocket::UDPSocket(SOCKET_ADDRESS_FAMILY domain)
 : BaseSocket(domain, SOCK_DGRAM)
{
    m_sockfd = socket (m_domain, m_type, m_protocol);
}

size_t UDPSocket::read(char *buffer, size_t size, sockaddr_in* from)
{
    socklen_t addrLength = sizeof(sockaddr_in);
    auto bytes = recvfrom(m_sockfd, buffer, (int) size, 0, (sockaddr*) from, &addrLength);
    if (bytes == -1)
        THROW_SOCKET_ERROR("Can't read to socket");
    return (size_t) bytes;
}
